#ifndef FIRE_KEYCOUNTER_H
#define FIRE_KEYCOUNTER_H

#include <fire/private/prefix.h>
#include <iostream>

namespace FIRE_NAMESPACE {

class RT_API KeyCounter {
  public:
    KeyCounter();
    KeyCounter(const char* key, const char* counter);
    KeyCounter(KeyCounter&&);
    KeyCounter(const KeyCounter&);
    KeyCounter& operator=(KeyCounter&&);
    KeyCounter& operator=(const KeyCounter&);
    ~KeyCounter();

    const char* get_key() const;
    const char* get_counter() const;

  private:
    class Impl;
    Impl* impl;

    friend RT_API std::ostream& operator<<(std::ostream&     os,
                                           const KeyCounter& val);

};  // class

}  // namespace FIRE_NAMESPACE

#endif  // FIRE_KEYCOUNTER_H
