#ifndef FIRE_RT_ERRNO_H_
#define FIRE_RT_ERRNO_H_

#include <fire/private/prefix.h>

namespace FIRE_NAMESPACE {

enum rt_errno {
  RT_NO_ERROR    =  0,   // All is good...
  RT_E_START     = -50,  // Start of RT errors
  RT_E_UNKNOWN   = -51,  // Unknown error
  RT_E_NO_SERV   = -52,  // No Service Available
  RT_E_NOT_FOUND = -53,  // Field, or Record not found
  RT_E_RENAME    = -54,  // Record has been renamed
  RT_E_TIMEDOUT  = -55,  // Operation timed out
  RT_E_EXISTS    = -56,  // Already exists
  RT_E_LIMIT     = -57,  // Maximum application limit has been reached
  RT_E_PROTOCOL  = -58,  // Any Protocol error (message, file format, network)
  RT_E_INVAL     = -59,  // Invalid parameter to method call
  RT_E_RESOURCE  = -60,  // Operating system resource exhausted
  RT_E_NO_CONN   = -61,  // No connection to the server
  RT_E_VERSION   = -62,  // Incorrect version
  RT_E_SHUTDOWN  = -63,  // User has shutdown the system
  RT_E_ACCESS    = -64,  // Permission denied
  RT_E_END       = -65   // End of RT errors
};

} // namespace

#endif

