#ifndef __FIRE_PREFIX_H__
#error "Please do not include this file directly, use prefix.h"
#endif

#ifndef __linux__
#error "ERROR: This include file is for Linux only"
#endif

/*
 * Lets do some error checking first
 */
#if !defined(__GNUC__) || !defined(__GXX_ABI_VERSION)
#error "ERROR: Unknown compiler, fdsrt only supports Gnu's C++ compiler on Linux"
#endif

#if !defined(_REENTRANT)
#error "ERROR: fdsrt requires the -pthread compiler switch on Linux"
#endif

#if defined(__x86_64__) || defined(__x86_64)
#include <fire/private/fire_linux64_prefix.h>
#elif defined(__i386)
#include <fire/private/fire_linux32_prefix.h>
#else 
#error "ERROR: fdsrt supports only Intel 386 (32/64bit) architectures on Linux"
#endif

#if defined(FDS_ONLINE)
#define RT_API FDS_EXPORT
#define FIRE_API FDS_EXPORT
#else
#define RT_API
#define FIRE_API
#endif
