//
// Inline implementations of the FDF class
//
// TODO: remove this macro
#define FDF_API (FIRE_NAMESPACE::RT_Consumer::get_default())

RT_API void rt_log_p(RT_LogLevel severity, const char *msg, size_t size,
                      const char *file, int line);

inline void FDF::set_connection_ctrl_cb(RT_Consumer::CtrlCB cb, void *close,
                                        void **old_closure /* = NULL */)
{ FDF_API.set_connection_ctrl_cb(cb, close, old_closure); }

inline const char *FDF::get_connection_info(size_t *dest_sz /* = NULL */)
{ return FDF_API.get_connection_info(dest_sz); }

inline rt_errno FDF::set_connection_info(const char *connection_string)
{ return FDF_API.set_connection_info(connection_string); }

inline rt_errno FDF::set_connection_info(const char *host_name,
                                         const char *user,
                                         const char *passwd)
{ return FDF_API.set_connection_info(host_name, user, passwd); }

inline rt_errno FDF::set_connection_info(const char* host_port,
                                         const char* user,
                                         const char* file_name,
                                         const char* key,
                                         const char* counter,
                                         const char* path,
                                         bool        force_input,
                                         bool        machine_account)
{
    return FDF_API.set_connection_info(host_port,
                                       user,
                                       file_name,
                                       key,
                                       counter,
                                       path,
                                       force_input,
                                       machine_account);
}

inline rt_errno FDF::set_otp_app_id(const char* app_id)
{
    return FDF_API.set_otp_app_id(app_id);
}

inline rt_errno FDF::set_otp_device_id(const char* device_id)
{
    return FDF_API.set_otp_device_id(device_id);
}

inline rt_errno FDF::request_passcode(const char* user, const char* serial)
{
    return FDF_API.request_passcode(user, serial);
}

inline rt_errno FDF::get_key_and_counter(const char* user,
                                         const char* serial,
                                         const char* passcode,
                                         KeyCounter& key_counter_out)
{
    return FDF_API.get_key_and_counter(user, serial, passcode, key_counter_out);
}

inline rt_errno FDF::connect(bool async_connect /* = false */)
{ return FDF_API.connect(async_connect); }

inline bool FDF::is_connected()
{ return FDF_API.is_connected(); }

inline const char *FDF::get_connected_host()
{ return FDF_API.get_connected_host(); }

inline rt_errno FDF::workstation_connect(const char *user,
                                         const char *passwd /* = "" */,
                                         bool async_connect /* = false */)
{ return FDF_API.workstation_connect(user, passwd, async_connect); }

inline rt_errno FDF::disconnect(bool keep_registrations /* = false */)
{ return FDF_API.disconnect(keep_registrations); }

inline RT_Consumer::NtfyFxn FDF::set_notify_function(RT_Consumer::NtfyFxn notify_fxn,
                              void *closure,
                              RT_Consumer::NtfyFxn thread_create_fxn /* = NULL */,
                              RT_Consumer::NtfyFxn thread_destroy_fxn /* = NULL */,
                              void **old_closure /* = NULL */)
{ return FDF_API.set_notify_function(notify_fxn, closure,
                         thread_create_fxn, thread_destroy_fxn, old_closure); }

inline rt_errno FDF::get_notify_socket(void *socket)
{ return FDF_API.get_notify_socket(socket); }

inline rt_errno FDF::lock()
{ return FDF_API.lock(); }

inline rt_errno FDF::unlock()
{ return FDF_API.unlock(); }

inline rt_errno FDF::create_mswin_dispatch_window()
{ return FDF_API.create_mswin_dispatch_window();  }

inline rt_errno FDF::destroy_mswin_dispatch_window()
{ return FDF_API.destroy_mswin_dispatch_window(); }

inline rt_errno FDF::dispatch(int max_wait_time_in_ms /* = 0 */)
{ return FDF_API.dispatch(max_wait_time_in_ms); }

inline rt_errno FDF::request(const class RT_Request &req, RT_Consumer::MesgCB cb,
                        void *closure, int *tag)
{ return FDF_API.request(req, cb, closure, tag); }

inline rt_errno FDF::request(const class RT_Request &req, RT_Consumer::MesgCB cb,
                        void *closure, std::vector<int> &tags)
{ return FDF_API.request(req, cb, closure, tags); }

inline rt_errno FDF::cancel(int tag, void **closure /* = NULL */)
{ return FDF_API.cancel(tag, closure); }

inline rt_errno FDF::get_record(int tag, const RT_Record **r,
                                void **closure /* = NULL */)
{ return FDF_API.get_record(tag, r, closure); }


inline size_t   FDF::get_services(RT_Message *msg)
{ return FDF_API.get_services(msg); }

inline rt_errno FDF::update_cb(int tag, RT_Consumer::MesgCB cb, void *closure,
                                     void **old_closure /* = NULL */)
{ return FDF_API.update_cb(tag, cb, closure, old_closure); }

inline unsigned int FDF::num_tags(unsigned int *srv_tags)
{ return FDF_API.num_tags(srv_tags); }

inline int FDF::get_next_tag(int tag_after, unsigned int *srv_tag /* = NULL */)
{ return FDF_API.get_next_tag(tag_after, srv_tag); }

//  plug-ins
inline bool FDF::enable(RT_Feature &ftr)
{ return FDF_API.enable(ftr); }

inline bool FDF::disable(RT_Feature &ftr)
{ return FDF_API.disable(ftr); }

inline bool FDF::is_active(RT_Feature &ftr)
{ return FDF_API.is_active(ftr); }

inline void FDF::set_send_unchanged_fields(bool enable) 
{  FDF_API.set_send_unchanged_fields(enable); }

inline bool FDF::set_http_proxy(const char *proxy_host)
{ return FDF_API.set_http_proxy(proxy_host); }

inline bool FDF::set_http_proxy(const char *proxy_host,
                                const char *proxy_user,
                                const char *proxy_password)
{ return FDF_API.set_http_proxy(proxy_host, proxy_user, proxy_password); }

inline void FDF::set_high_water_mark(unsigned int high_water_mark)
{ FDF_API.set_high_water_mark(high_water_mark); }

inline unsigned int FDF::get_high_water_mark()
{ return FDF_API.get_high_water_mark(); }

inline size_t FDF::message_queue_size()
{ return FDF_API.message_queue_size(); }

inline void FDF::clear_queue()
{ FDF_API.clear_queue(); }

#undef FDF_API
