#!/bin/sh

CWD=`pwd`
mydir=`dirname $0`
cd $mydir

SYSTEM="`uname -s`"
if [ "$SYSTEM" = "SunOS" ]; then
  CC="CC"
  CC_WARN_FLAGS=""
  CC_RELEASE_FLAGS="-mt -g -O3 -DNDEBUG"
  CC_DEBUG_FLAGS="-mt -g -D_DEBUG"
else
  CC="g++"
  CC_WARN_FLAGS="-Wall"
  CC_RELEASE_FLAGS="-pthread -g -O3 -DNDEBUG"
  CC_DEBUG_FLAGS="-pthread -g -D_DEBUG"
fi

INSTALL_DIR="`cat ../../../etc/RT_INSTALLATION_DIR.TXT`"
PLATFORM="`cat ../../../etc/RT_PLATFORM.TXT`"
INC_PATH="../../../include"
LIB_PATH="../../../lib/platform"
RUN_PATH="${INSTALL_DIR}/lib/${PLATFORM}"
LD_FLAGS="-Wl,-rpath,$RUN_PATH"
SOURCES="text_quote.cpp"
EXE_FILE="text_quote"

#
# Make the CC flags, and handle debug and release compilations
#
CC_FLAGS="-I$INC_PATH -L$LIB_PATH $CC_WARN_FLAGS"
if [ "$1" = "debug" ]; then
  CC_FLAGS="$CC_FLAGS $CC_DEBUG_FLAGS"
  LIB_NAME="fdsrtd"
else
  CC_FLAGS="$CC_FLAGS $CC_RELEASE_FLAGS"
  LIB_NAME="fdsrt"
fi

echo "Compiling $SOURCES"
echo
echo $CC $CC_FLAGS $SOURCES $LD_FLAGS -o $EXE_FILE -l$LIB_NAME
$CC $CC_FLAGS $SOURCES $LD_FLAGS -o $EXE_FILE -l$LIB_NAME || echo "Compilation failed!!"

cd $CWD
exit 0
