#include <iostream>
#include <FDS/rt_api.h>
#include <FDS/rt_fields.h>

using namespace std;
using namespace FDS;

static void on_message(int tag, const RT_Message *msg, const RT_Record *rec, void *closure)
{
   RT_Field field = msg->get(FIDS::MSG_TYPE);
   cout << "Message Type " << field.to_string() << endl;
   cout << endl;

   cout << "RT Message" << endl;
   cout << msg->get_key() << "\n" << *msg << endl;
   cout << endl;

   cout << "RT Record" << endl;
   cout << *rec << endl;
   cout << endl;
}

int main(int argc, char *argv[])
{
   if(argc < 2)
   {
      std::cerr << "Usage: " << argv[0] << " <user-serial>:<password>@<hostname>" << endl;
      return 1;
   }

   RT_Consumer consumer;
   consumer.set_connection_info(argv[1]);
   consumer.connect();

   RT_Request req1("FDS1", "AAPL");
   int tag1 = 0;
   consumer.request(req1, on_message, NULL, &tag1);

   RT_Request req2("FDS1", "GOOG");
   int tag2 = 0;
   consumer.request(req2, on_message, NULL, &tag2);

   RT_Request req3("FDS1", "LLL");
   int tag3 = 0;
   consumer.request(req3, on_message, NULL, &tag3);

   while (true)
   {
      consumer.dispatch(-1);
   }

   return 0;
}
